/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// OperationRequestInnerJoin - struct for OperationRequestInnerJoin
type OperationRequestInnerJoin struct {
	InnerJoinRequest *InnerJoinRequest
}

// InnerJoinRequestAsOperationRequestInnerJoin is a convenience function that returns InnerJoinRequest wrapped in OperationRequestInnerJoin
func InnerJoinRequestAsOperationRequestInnerJoin(v *InnerJoinRequest) OperationRequestInnerJoin {
	return OperationRequestInnerJoin{
		InnerJoinRequest: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *OperationRequestInnerJoin) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into InnerJoinRequest
	err = newStrictDecoder(data).Decode(&dst.InnerJoinRequest)
	if err == nil {
		jsonInnerJoinRequest, _ := json.Marshal(dst.InnerJoinRequest)
		if string(jsonInnerJoinRequest) == "{}" { // empty struct
			dst.InnerJoinRequest = nil
		} else {
			match++
		}
	} else {
		dst.InnerJoinRequest = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.InnerJoinRequest = nil

		return fmt.Errorf("data matches more than one schema in oneOf(OperationRequestInnerJoin)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(OperationRequestInnerJoin)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src OperationRequestInnerJoin) MarshalJSON() ([]byte, error) {
	if src.InnerJoinRequest != nil {
		return json.Marshal(&src.InnerJoinRequest)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *OperationRequestInnerJoin) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.InnerJoinRequest != nil {
		return obj.InnerJoinRequest
	}

	// all schemas are nil
	return nil
}

type NullableOperationRequestInnerJoin struct {
	value *OperationRequestInnerJoin
	isSet bool
}

func (v NullableOperationRequestInnerJoin) Get() *OperationRequestInnerJoin {
	return v.value
}

func (v *NullableOperationRequestInnerJoin) Set(val *OperationRequestInnerJoin) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequestInnerJoin) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequestInnerJoin) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequestInnerJoin(val *OperationRequestInnerJoin) *NullableOperationRequestInnerJoin {
	return &NullableOperationRequestInnerJoin{value: val, isSet: true}
}

func (v NullableOperationRequestInnerJoin) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequestInnerJoin) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
